/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* $Id: metric.c,v 1.7 1999/03/26 00:48:32 elca Exp $ */

/* metric.c: ʸ礭׻ */

#include <math.h>
#include "metric.h"

/* ʲͼθ */
inline int d_to_i(double d)
{
	return (int)(d + 0.5);
}

inline double fmin(double a, double b)
{
	if(a < b) {
		return a;
	}
	return b;
}

inline double fmin4(double a, double b, double c, double d)
{
	return fmin(fmin(a, b), fmin(c, d));
}

inline double fmax(double a, double b)
{
	if(a > b) {
		return a;
	}
	return b;
}

inline double fmax4(double a, double b, double c, double d)
{
	return fmax(fmax(a, b), fmax(c, d));
}

/* ʸ */
inline double computeWidth(double matrix[4])
{
	return fmax4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2])
		- fmin4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2]);
}

/* ʸι⤵ */
inline double computeHeight(double matrix[4])
{
	return fmax4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3])
		- fmin4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3]);
}

/* ʸ */
inline double computeChWidth(double matrix[4])
{
	return fmax(fabs(matrix[0]), fabs(matrix[2]));
}

/*  */
inline double computeChHeight(double matrix[4])
{
	return fmax(fabs(matrix[1]), fabs(matrix[3]));
}


/* ʸκѤȺɸ (0,0) ȤΤ */
inline double computeXdelta(double matrix[4])
{
	return fabs(fmin4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2]));
}

/* ʸκѤȺɸ (0,0) ȤΤ */
inline double computeYdelta(double matrix[4])
{
	return fabs(fmin4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3]));
}

/* end */
